#define F_CPU 16000000

#include "usart.h"

#include <avr/io.h>
#include <util/delay.h>


/* Aprinde led-ul PC0 la apasarea butonului PB0. */
void exemplu(void) {
	/* Setez pinul PB0 ca intrare. */
	DDRB &= ~(1 << PB0);

	/* Activez rezistenta de pull-up pentru pinul PB0. */
	PORTB |= (1 << PB0);

	/* Setez pinul PC0 ca iesire. */
	DDRC |= (1 << PC0);

	/* Sting LED-ul. */
	PORTC &= ~(1 << PC0);

	while (1) {
		/* Daca butonul este apasat. */
		if ((PINB & (1 << PB0)) == 0)
			/* Aprind LED-ul. */
			PORTC |= (1 << PC0);
		else
			/* Sting LED-ul. */
			PORTC &= ~(1 << PC0);
	}
}

void init_timer1(){
	//top=20000, prescaler=8, frec=50hz (T=20ms)
	ICR1=20000;
	TCCR1B|=_BV(CS11);
	
	//phase and frequency correction, icr1 = top
	TCCR1B|=_BV(WGM13);
	//set OC1A,OC2B on downcounting, clear on upcounting
	TCCR1A|=_BV(COM1A1)|_BV(COM1B1);
	//output pins, PORTD4 (motor 2) and PORTD5 (motor 1)
	DDRD|=_BV(4)|_BV(5);
	
	//default position
	OCR1A=1500;//portd5
	OCR1B=1500;//portd4
	
}

void init_butoane() {
	/* Setez pinul PA0 ca intrare. */
	DDRA &= ~(1 << PA0);

	/* Activez rezistenta de pull-up pentru pinul PA0. */
	PORTA |= (1 << PA0);
	
	/* Setez pinul PA1 ca intrare. */
	DDRA &= ~(1 << PA1);

	/* Activez rezistenta de pull-up pentru pinul PA1. */
	PORTA |= (1 << PA1);
	
	/* Setez pinul PA2 ca intrare. */
	DDRA &= ~(1 << PA2);

	/* Activez rezistenta de pull-up pentru pinul PA2. */
	PORTA |= (1 << PA2);
}

void init_pini_usart() {
	/* Setez pinul PD0 ca intrare. */
	DDRD &= ~(1 << PD0);
	
	/* Setez pinul PD1 ca iesire. */
	DDRD |= (1 << PD1);
}

void init_led_test() {
	/* Setez pinul PD7 ca iesire. */
	DDRD |= (1 << PD7);

	/* Sting LED-ul. */
	PORTD &= ~(1 << PD7);
}

int main(void) {
	/*exemplu();*/
	
	init_pini_usart();
	init_butoane();
	USART0_init();
	init_timer1();
	init_led_test();
	
	while (1) {
		if ((PINA & (1 << PA0)) == 0) {
			OCR1B += 25;
			_delay_ms(50);
		}
		
		if ((PINA & (1 << PA1)) == 0) {
			OCR1B -= 25;
			_delay_ms(50);
		}
		
		if ((PINA & (1 << PA2)) == 0) {
			char ch = 'q', ch_test;
			
			ch_test = USART0_receive();
			if (ch_test == ch) {
				/* Aprind LED-ul. */
				PORTD |= (1 << PD7);
				
				_delay_ms(500);
				
				/* Sting LED-ul. */
				PORTD &= ~(1 << PD7);
			}
			
			USART0_transmit(ch_test + 1);
		}
	}
	
	return 0;
}
